<template>
  <div class="account-path">
    <div class="account-path__row">
      <div class="account-path__from">

        <div class="account-path__date">
          {{ order.shipmentPoints[0].plannedSlotStartAt | date }}
        </div>
        <div class="account-path__time">
          {{ transformTime(order.shipmentPoints[0].plannedSlotStartAt) }} -
          {{ transformTime(order.shipmentPoints[0].plannedSlotEndAt) }}
        </div>
      </div>

      <div v-if="order.distance" class="account-path__distance">
        <i class="icon route"/>
        {{ order.distance }} км
      </div>

      <div class="account-path__to">
        <div class="account-path__date">
          {{ order.shipmentPoints[order.shipmentPoints.length - 1].plannedSlotStartAt | date }}
        </div>
        <div class="account-path__time">
          {{ transformTime(order.shipmentPoints[order.shipmentPoints.length - 1].plannedSlotStartAt) }} -
          {{ transformTime(order.shipmentPoints[order.shipmentPoints.length - 1].plannedSlotEndAt) }}
        </div>
      </div>

    </div>

    <div class="account-path__row account-path__point">
      <div class="account-path__point-start"></div>
      <div class="account-path__point-dots"></div>
      <div class="account-path__point-dots"></div>
      <div
          v-if="order.shipmentPoints.length > 2"
          class="account-path__point-dots"
      >
        <div class="account-path__point-dots-square">
          +{{order.shipmentPoints.length - 2}}
        </div>
      </div>

      <div class="account-path__point-end"></div>
    </div>

    <div class="account-path__row">
      <div class="account-path__adress">
        <div class="account-path__adress-city">
          {{ order.shipmentPoints[0].title }}
        </div>
        <div class="account-path__adress-street">
          {{ order.shipmentPoints[0].addressTitle }}
        </div>
      </div>
      <div class="account-path__adress">
        <div class="account-path__adress-city">
          {{ order.shipmentPoints[order.shipmentPoints.length - 1].title }}
        </div>
        <div class="account-path__adress-street">
          {{ order.shipmentPoints[order.shipmentPoints.length - 1].addressTitle }}
        </div>

      </div>
    </div>

    <div v-if="order.shipmentPoints.length > 2" class="account-path__route-list">
      <a @click="$refs['show-list-router'].open()">Показать маршрут списком</a>
    </div>

    <ob-modal
        ref="show-list-router"
        size="extra-large"
        :title="`Маршрут заказа ${order.shipmentPoints[0].addressTitle} → ${order.shipmentPoints[order.shipmentPoints.length - 1].addressTitle}`"
        is-center
        is-nested
        data-qa="addContractorModal"
        cancel-text="Закрыть"
        :is-show-controls="true"
        :is-read-only="true"
    >
      <list-routes :items="order.shipmentPoints" />
    </ob-modal>
  </div>
</template>

<script>
import { mapGetters } from 'vuex';
import moment from 'moment';
import ObModal from "common-components/src/obComponents/obModal";
import ListRoutes from "./list-routes"

  export default {
    components: {
      ObModal,
      ListRoutes
    },
    computed: {
      ...mapGetters({
        order: 'account/order'
      })
    },
    methods: {
      transformTime(time) {
        return moment(time).format('HH:mm')
      }
    }
  }
</script>

<style lang="scss" scoped>
@import "~common-components/src/static/css/variables";

.account-path {

  font-size: 12px;
  line-height: 16px;
  letter-spacing: 0.2px;
  mix-blend-mode: normal;
  width: 100%;

  &__row {
    display: flex;
    justify-content: space-between;
    margin-top: 20px;
  }

  &__date {
    color: $color-text-base;
  }

  &__time {
    color: $gray-slate;
  }
  &__distance {
    display: flex;
    font-weight: bold;
    font-size: 12px;
    line-height: 12px;
    letter-spacing: 0.4px;
    color: $gray-slate;
    align-items: center;
    
    .icon {
      font-size: 16px;
      margin-right: 6px;
    }
  }
  &__point {
    display: flex;
    justify-content: space-between;
    align-items: flex-end;
    height: 52px;
    &-start, &-end {
      background: $account-path_point_dots;
      width: 2px;
      height: 52px;
      position: relative;
      &:before {
        width: 0;
        height: 0;
        border-style: solid;
        content: '';
        position: absolute;
        top: -10px;
      }
      &:after {
        width: 10px;
        height: 10px;
        border-radius: 50%;
        position: absolute;
        content: '';
        background: $account-path_point_dots;
        bottom: -4px;
        left: -4px;
      }
    }
    &-start {
      margin-left: 5px;
      &:before {
        border-width: 10px 6px 0 6px;
        border-color: #FFB137 transparent transparent transparent;
        left: -5px;
      }
    }
    &-end {
      &:before {
        border-width: 0 6px 10px 6px;
        border-color: transparent transparent #10CF96 transparent;
        right: -5px;
      }
    }
    &-dots {
      flex-grow: 12;
      height: 1px;
      border: 1px dashed $account-path_point_dots;
      &-square {
        border: 1px solid $account-path_point_dots;;
        background: $background-color-light;
        width: 30px;
        text-align: center;
        position: absolute;
        left: calc(50% - 18px);
        top: 153px;
        border-radius: 4px;
      }

    }
  }
  &__adress {
    display: flex;
    flex-direction: column;
    font-size: 10px;
    line-height: 16px;
    mix-blend-mode: normal;

    &-city {
      color: $shale-gray;
      font-weight: bold;
      text-transform: uppercase;
    }
    &-street {
      font-size: 12px;
      color: $gray-slate;
    }

    &:last-child {
      text-align: right;
    }
  }
  &__route-list {
    padding: 10px 0 0;
    a {
      font-size: 12px;
      line-height: 12px;
      letter-spacing: 0.4px;
      color: $color-blue-navy-blue;
      cursor: pointer;
    }
  }
}

</style>